package ping;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Properties;

public class PingClient
{
    public static void main(String[] args) throws NamingException
    {
//        lookupHttp();
        lookupHttps();
    }

    private static void lookupHttps() throws NamingException
    {
        final Properties jndiConfig = new Properties();
        jndiConfig.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
        jndiConfig.put(Context.PROVIDER_URL, "https-remoting://localhost:8443");
        jndiConfig.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiConfig.put(Context.SECURITY_PRINCIPAL, "gandalf");
        jndiConfig.put(Context.SECURITY_CREDENTIALS, "gandalf");
        jndiConfig.put("org.jboss.ejb.client.scoped.context", "true");

        jndiConfig.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "true");
        jndiConfig.put("remote.connections", "default");
        jndiConfig.put("remote.connection.default.host", "localhost");
        jndiConfig.put("remote.connection.default.port", "8443");
        jndiConfig.put("remote.connection.default.protocol", "https-remoting");
        jndiConfig.put("remote.connection.default.connect.options.org.xnio.Options.SSL_JSSE_TRUST_MANAGER_CLASSES",
                PingTrustManager.class.getName());
        jndiConfig.put("remote.connection.default.connect.options.org.xnio.Options.SSL_PROTOCOL", "TLSv1.2");

        InitialContext ic = new InitialContext(jndiConfig);
        RemotePing ping = (RemotePing) ic.lookup("ejb:/ping-ejb-1.0-SNAPSHOT/PingEjb!ping.RemotePing");
        System.out.println("Received ping message: " + ping.ping());
    }

    private static void lookupHttp() throws NamingException
    {
        final Properties jndiConfig = new Properties();
        jndiConfig.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
        jndiConfig.put(Context.PROVIDER_URL, "http-remoting://localhost:8080");
        jndiConfig.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiConfig.put(Context.SECURITY_PRINCIPAL, "gandalf");
        jndiConfig.put(Context.SECURITY_CREDENTIALS, "gandalf");
        jndiConfig.put("org.jboss.ejb.client.scoped.context", "true");

        jndiConfig.put("remote.connections", "default");
        jndiConfig.put("remote.connection.default.host", "localhost");
        jndiConfig.put("remote.connection.default.port", "8080");
        jndiConfig.put("remote.connection.default.protocol", "http-remoting");

        InitialContext ic = new InitialContext(jndiConfig);
        RemotePing ping = (RemotePing) ic.lookup("ejb:/ping-ejb-1.0-SNAPSHOT/PingEjb!ping.RemotePing");
        System.out.println("Received ping message: " + ping.ping());
    }
}
